;***********************************************************
;*                LITE 2         
;*                 AT90S1200    
;* CLK   8.000 MGz
;* CIKL  125ns 
;* 
;* 
;***********************************************************


.include "1200def.inc";      
                      ; 


;    63  EEPROM
; MAX   62  EEPROM
; COMP   61  EEPROM

;   Q    
;   EEPROM. 
;                        60     0
;                        59     1
;			   58     2 
;			   ..


;   Q=2!!!!!! ( )
;   - 15 (   )
;   - 0
;    ~6 


; 


.DEF  COMP   =r24	;   (  )

.DEF  MAX    =r16	;     (0  2)

.DEF  S      =r26    ;   ()

.DEF  SS     =r18    ;  EEPROM    EEPROM

.DEF  T	      =r19    ;    (-   )

.DEF  Q      =r20	; (-    )

.DEF  J      =r21	; Q (    )	

.DEF  G      =r22     ;      

.DEF  A      =r23	;

.DEF  AA     =r29	; 

.DEF  DELAY  =r25	;   PAUSE_ms

.DEF  X      =r17	;   PAUSE_ms

.DEF  DEL    =r27	;  .  ()  

.DEF  DELL   =r28	;  .  ()

.DEF  EF1    =r15

.DEF  EF2    =r30	;  ( DEL  DELL)



.CSEG                  ;  
.ORG 0

        RJMP RESET      ;  reset
        NOP             ;  int
        NOP             ;  tmr0  
        RJMP COMPARATOR ;  compare

;-------------------------------------------------------------------
;   
;-------------------------------------------------------------------
COMPARATOR:
	
	RJMP OFF		;    

;-------------------------------------------------------------------


;********************************************************************
;
;********************************************************************

RESET:	
	CLI			; 

	LDI A,0B00001111	
	OUT WDTCR,A		; WDT
	

       	LDI A,0B00000000
	OUT TIMSK,A		; tmr0
       
	LDI A,0B00000000
	OUT MCUCR,A		; sleep
                  		;   int0   0

	LDI A,0B00000000
	OUT GIMSK,A		;   int0

	
	LDI A,0B00001000 		
	OUT ACSR,A		; ,  
				;,  .

	LDI A,0B00111100	
	OUT DDRB,A		;  .1-,0-
	LDI A,0B00000000
	OUT PORTB,A		;     .
				;., .,.
				;
	

	LDI A,0B01110000
	OUT DDRD,A		;  D.1-,0-
	LDI A,0B00001011
	OUT PORTD,A		;     
				;    
	
	

L55:	SBIC PIND,2
	RJMP L55 	;Ĩ     
L66:	SBIS PIND,2	
	RJMP L66 	;Ĩ     
	
	LDI DELAY,18
	RCALL PAUSE_MS	;   
	
				


	SBI PORTB,5		;  
	LDI DELAY,254
	RCALL PAUSE_MS
	LDI DELAY,254
	RCALL PAUSE_MS
	LDI DELAY,254
	RCALL PAUSE_MS
				;   ,  

	SBI PORTB,3		;  	

 	


INSTAL1:

	;  EEPROM   ( S=0  )

	LDI A,63
 	OUT EEAR,A	;   
	SBI EECR,EERE	; 
	IN S,EEDR	;  S  
	
 	LDI A,5
	CP A,S
	BRMI ERROR1	; S>5    ERROR1	
	RJMP INSTAL2	;   INSTAL2
	
ERROR1:
	WDR		; 
	LDI S,0		;       EEPROM
	LDI SS,63
 	MOV A,S		;    
	RCALL WR	;  


;  EEPROM  MAX ( MAX=0   )
;                                   ( MAX=3  )
INSTAL2:

	LDI A,62
 	OUT EEAR,A	;   
	SBI EECR,EERE	; 
	IN MAX,EEDR	;  MAX
	
 	
	CPI MAX,0	; =0 ( ) ,  
	BREQ INSTAL3	;  INSTAL3
	
	CPI MAX,3	; =3 ( ) ,  
	BREQ INSTAL3	;  INSTAL3

   ;  =0  =3     ERROR11


ERROR11:
	
	LDI MAX,3	;  MAX ( )    EEPROM
	LDI SS,62
	MOV A,MAX	;   
	RCALL WR	;  

	;  INSTAL3




	

;  EEPROM  COMP ( COMP=0   )
;  .       ,
;        .
;     EEPROM.


INSTAL3:

	;LDI A,61
 	;OUT EEAR,A	;   
	;SBI EECR,EERE	; 
	;IN COMP,EEDR	;  COMP 

	;TST COMP	; ?
	;BREQ COMPA	;     COMPA
	;SBI PORTD,6	;-   COMP
	;SEI		; 
	;RJMP INSTAL4	;  INSTAL4
	
;COMPA:
	;CBI PORTD,6  	;  COMP     INSTAL4
	;CLI		; 

	LDI COMP,1	;  .
	SBI PORTD,6	;  COMP
	SEI		;    


INSTAL4:
	
	TST MAX		;MAX ?
	BREQ MAXA	;     MAXA 
	SBI PORTD,4	;  (MAX-)   MAX
	RJMP INSTAL5	;  INSTAL5
	
MAXA:	CBI PORTD,4	;  MAX    INSTAL5
			
	


INSTAL5:
	CBI PORTD,5		;  (
	
;     . ( )
	
	SBIS PIND,0	;SPEED ?
	RCALL MAX_S	;,  MAX_S
	SBIS PIND,1	;PROG ?
	RCALL COMP_S	;,  COMP_S
			;      Ĩ  

	RCALL KM7

	RJMP DD


;-------------------------------------------------------------------
;           
;*******************************************************************








;-------------------------------------------------------------------
; 1     
;    ,  
;  ,  
;-------------------------------------------------------------------

KM1:
	MOV DEL,MAX
	LDI DELL,13                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          	
M0:	MOV J,Q		; J
	MOV EF1,DEL	; DEL
	MOV EF2,DELL	; DELL
	RCALL START	;   
	MOV DEL,EF1	; DEL
	MOV DELL,EF2	; DELL
	CPI DEL,13	;    ?
	BREQ M1 	; - 
	INC DEL		; 
	DEC DELL	; 
	RJMP M0 	;٨ 
M1:	RET
;===================================================================


;-------------------------------------------------------------------
; 2     
;    ,  
;     ,  .
;-------------------------------------------------------------------

KM2:
	LDI DEL,13
	MOV DELL,MAX                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          	
M2:	MOV J,Q		; J
	MOV EF1,DEL	; DEL
	MOV EF2,DELL	; DELL
	RCALL START	;   
	MOV DEL,EF1	; DEL
	MOV DELL,EF2	; DELL
	CP DEL,MAX	;    ?
	BREQ M3 	; - 
	DEC DEL		; 
	INC DELL	; 
	RJMP M2 	;٨ 
M3:	RET
;===================================================================



;-------------------------------------------------------------------
; 3   
;   ,  
;    , 
;-------------------------------------------------------------------

KM3:
	LDI DEL,11	
	LDI DELL,11	
M4:	MOV J,Q		; J
	MOV EF1,DEL	; DEL
	MOV EF2,DELL	; DELL
	RCALL START	;   
	MOV DEL,EF1	; DEL
	MOV DELL,EF2	; DELL
	CP DEL,MAX	;    ?
	BREQ M5 	; - 
	DEC DEL 	;  
	RJMP M4 	;٨ 
M5:	RET
;===================================================================


;-------------------------------------------------------------------
; 4  
;   ,  
;     
;-------------------------------------------------------------------

KM4:
	LDI DEL,11
	LDI DELL,11	
M6:	MOV J,Q		; J
	MOV EF1,DEL	; DEL
	MOV EF2,DELL	; DELL
	RCALL START	;   
	MOV DEL,EF1	; DEL
	MOV DELL,EF2	; DELL
	CP DELL,MAX	;    ?
	BREQ M7 	; - 
	DEC DELL 	;  
	RJMP M6 	;٨ 
M7:	RET
;===================================================================





;-------------------------------------------------------------------
; 5   
;   ,  
;    , 
;-------------------------------------------------------------------

KM5:
	MOV DEL,MAX	
	MOV DELL,MAX	
M8:	MOV J,Q		; J
	MOV EF1,DEL	; DEL
	MOV EF2,DELL	; DELL
	RCALL START	;   
	MOV DEL,EF1	; DEL
	MOV DELL,EF2	; DELL
	CPI DEL,15	;    ?
	BREQ M9 	; - 
	INC DEL 	;  
	RJMP M8 	;٨ 
M9:	RET
;===================================================================





;-------------------------------------------------------------------
; 6  
;   ,  
;    , 
;-------------------------------------------------------------------

KM6:
	MOV DEL,MAX	
	MOV DELL,MAX	
M10:	MOV J,Q		; J
	MOV EF1,DEL	; DEL
	MOV EF2,DELL	; DELL
	RCALL START	;   
	MOV DEL,EF1	; DEL
	MOV DELL,EF2	; DELL
	CPI DELL,15	;    ?
	BREQ M11 	; - 
	INC DELL 	;  
	RJMP M10 	;٨ 
M11:	RET
;===================================================================





;-------------------------------------------------------------------
; 7 
;-------------------------------------------------------------------

KM7:
	LDI DEL,18
	LDI DELL,18                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          	
M12:	LDI J,254 	; J
	MOV EF1,DEL	; DEL
	MOV EF2,DELL	; DELL
	RCALL START	;   
	MOV DEL,EF1	; DEL
	MOV DELL,EF2	; DELL
	CP DEL,MAX	;    ?
	BREQ M13 	; - 
	DEC DEL		; 
	DEC DELL	; 
	RJMP M12 	;٨ 
M13:	RET
;===================================================================























;------------------------------------------------------------------
;  
;------------------------------------------------------------------

DD:	TST S
	BREQ AUTO	; S=0 ()   AUTO

	RJMP DD1	; S  0 ( )   DD1

AUTO:  SBI PORTD,5
	RJMP EFEKT1	; S=0   ""      


DD1:	CBI PORTD,5	;  "" 
	CPI S,1
	BREQ EFEKT1	; S=1     	
	CPI S,2
	BREQ EFEKT2	; S=2     
	CPI S,3
	BREQ EFEKT3	; S=3     
	CPI S,4
	BREQ EFEKT4	; S=4     
	CPI S,5
	BREQ STEK5	; S=5     
	CPI S,6
	BREQ STEK6	; S=6    



STEK5:	RJMP EFEKT5 	;  
STEK6:	RJMP EFEKT6 	;  





EFEKT1:
	LDI SS,60
	RCALL EEPROM_RD
	MOV Q,A		;  EEPROM  EFEKT1
	LDI T,100	;    
	

EFEK1:	SBI PORTB,3	; 
	RCALL KM1
	CBI PORTB,3	; 
	RCALL KM2

	

	DEC T
	TST T
	BRNE EFEK1	;     =0
	TST S		; S=0  ,   
	BRNE EFEKT1	; S HE=0  ,  .



;************************************************************************
EFEKT2:
	LDI SS,59
	RCALL EEPROM_RD
	MOV Q,A		;  EEPROM  EFEKT2
	LDI T,100	;    

	

EFEK2:	SBI PORTB,3	; 
	RCALL KM1
	CBI PORTB,3	; 
	RCALL KM2

	
	DEC T
	TST T
	BRNE EFEK2
	TST S		; S=0  ,   
	BRNE EFEKT2	; S HE=0  ,  
;************************************************************************


		
	
;************************************************************************
EFEKT3:
	LDI SS,58
	RCALL EEPROM_RD
	MOV Q,A		;  EEPROM  EFEKT3

	LDI T,100 	;    

	

EFEK3:	SBI PORTB,3	; 
	RCALL KM1
	CBI PORTB,3	; 
	RCALL KM2	

	
	
	DEC T
	TST T
	BRNE EFEK3
	TST S		; S=0  ,   
	BRNE EFEKT3	; S HE=0  ,  .
;*************************************************************************


EFEKT4:
	LDI SS,57
	RCALL EEPROM_RD
	MOV Q,A		;  EEPROM  EFEKT4
	
	LDI T,100	;    

	
EFEK4:	
	SBI PORTB,3	; 
	RCALL KM3
	CBI PORTB,3	; 
	RCALL KM4

	

	DEC T
	TST T
	BRNE EFEK4	;     =0
	TST S		; S=0  ,   
	BRNE EFEKT4	; S HE=0  ,  .




	




EFEKT5:
	LDI SS,56
	RCALL EEPROM_RD
	MOV Q,A		;  EEPROM  EFEKT5
	LDI T,100	;    

	

EFEK5:	SBI PORTB,3	; 
	RCALL KM3
	CBI PORTB,3	; 
	RCALL KM4

	

	
	DEC T
	TST T
	BRNE EFEK5
	TST S		; S=0  ,   
	BRNE EFEKT5	; S HE=0  ,  .







EFEKT6:
	LDI SS,55
	RCALL EEPROM_RD
	MOV Q,A		;  EEPROM  EFEKT6
	LDI T,100	;    
	
	

EFEK6:	SBI PORTB,3	; 
	RCALL KM5
	CBI PORTB,3	; 
	RCALL KM6

	


	
	DEC T
	TST T
	BRNE EFEK6
	TST S		; S=0  ,   
	BRNE EFEKT6	; S HE=0  ,  .

















	RJMP EFEKT1	;   ,   







;------------------------------------------------------------------
;            



;******************************************************************
;    ,   
;******************************************************************


START:
	
	WDR		; 

	CP DEL,DELL
	BREQ RAVNO	;DEL=DELL	
	BRHS MENSE	;DEL<DELL
	RJMP BOLSE	;DEL>DELL
	
;************ END PROCEDURE ***************************************






;******************************************************************
;    DEL=DELL
;******************************************************************


RAVNO:
	

	DEC J		;      ?
	BRNE L1 	;     L1  
	RET
	
	
L1:	SBIC PIND,2
	RJMP L1 	;Ĩ     
	
	

L2:	SBIS PIND,2
	
	RJMP L2 	;Ĩ     


	MOV DELAY,DEL	
	RCALL PAUSE_MS	;  (  )


	SBI PORTB,2
	SBI PORTB,4	; 
	LDI A,255
L3:	DEC A
	BRNE L3
	CBI PORTB,2
	CBI PORTB,4	;  (  9.)
	
	
	LDI G,0		;     KNOPKI
	
	RJMP KNOPKI 	;   
	
	

;************ END PROCEDURE ****************************************




;*******************************************************************
;    DEL<DELL
;*******************************************************************

MENSE:
	
	
	SUB DELL,DEL	;    ( DELL )
	
MENS:	DEC J		;      ?
	BRNE L4 	;     L4  
	RET
	
	
L4:	SBIC PIND,2
	RJMP L4 	;Ĩ     

	

L5:	SBIS PIND,2
	
	RJMP L5 	;Ĩ     


	MOV DELAY,DEL	
	RCALL PAUSE_MS	;    
			;(  )


	SBI PORTB,2	;
	LDI A,255
L6:	DEC A
	BRNE L6		;    
	CBI PORTB,2	;      9.)

	MOV DELAY,DELL	
	RCALL PAUSE_MS	;    
			;(  )

	SBI PORTB,4	;
	LDI A,255
L7:	DEC A
	BRNE L7		;    
	CBI PORTB,4	;      9.)

	LDI G,1		;     KNOPKI
	
	RJMP KNOPKI 	;   	

	
	
;************ END PROCEDURE ****************************************

YY:	RJMP RAVNO	;  


;*******************************************************************
;    DEL>DELL
;*******************************************************************


BOLSE:
	

	SUB DEL,DELL	;    ( DEL )
	
BOLS:	DEC J		;      ?
	BRNE L8 	;     L8  
	RET
	
	
L8:	SBIC PIND,2
	RJMP L8 	;Ĩ     

	

L9:	SBIS PIND,2
	
	RJMP L9 	;Ĩ     


	MOV DELAY,DELL	
	RCALL PAUSE_MS	;    
			;(  )

	SBI PORTB,4
	LDI A,255
L10:	DEC A
	BRNE L10	;    
	CBI PORTB,4	;      9.)
	

	MOV DELAY,DEL	
	RCALL PAUSE_MS	;    
			;(  )

	SBI PORTB,2
	LDI A,255
L11:	DEC A
	BRNE L11	;    
	CBI PORTB,2	;      9.)	
		
	LDI G,2		;     KNOPKI
	
	RJMP KNOPKI 	;   
	
	
	
;************ END PROCEDURE ****************************************









;*******************************************************************
;     
;*******************************************************************


KNOPKI:
	
	WDR		; 

	SBIS PIND,0	;SPEED ?
	RJMP SPEED	;,  SPEED
	SBIS PIND,1	;PROG ?
	RJMP PROG	;,  PROG
	SBIS PIND,3	;OFF?
	RJMP OFF	;.  OFF
			;      Ĩ  Y
Y:
	
	TST G
	BREQ YY 	; G=0    RAVNO  YY (  )
	CPI G,1
	BREQ MENS	; G=1    MENS
	RJMP BOLS	; -,- (G=2)    BOLS



	
SPEED:
	LDI DELAY,200
	RCALL PAUSE_MS ; 100.-  
	SBIS PIND,0	;SPEED   ?
	RJMP SPEED1	;,   SPEED 
	RJMP Y		;    

	
SPEED1:
	
	SBIS PIND,0	
	RJMP SPEED1	;Ĩ    SPEED

	LDI DELAY,200
	RCALL PAUSE_MS ; 100.-  

	CPI Q,8		;,Q    8?
	BREQ SPEED2	;     SPEED2
	INC Q		; Q   8   Q  1

	
SR1:	SBIC EECR,EEWE	;Ĩ  
	RJMP SR1		
	OUT EEAR,SS	;    
	OUT EEDR,Q	; 
	SBI EECR,EEWE	;   EEPROM
SR2:	SBIC EECR,EEWE	
	RJMP SR2	;Ĩ   EEPROM  		
	
	RJMP Y  	;

SPEED2:
	LDI Q,2		; Q   8  Q=2
	RJMP SR1	;      



			


PROG:
	
	LDI DELAY,200
	RCALL PAUSE_MS ; 100.-  
	SBIS PIND,1	;PROG   ?
	RJMP PROG1	;,   PROG
	RJMP DD		; ,   


PROG1:
	SBIS PIND,1	
	RJMP PROG1	;Ĩ    PROG

	LDI DELAY,200
	RCALL PAUSE_MS ; 100.-  

	CPI S,6		;,S    6?
	BREQ PROG2	;     PROG2
	INC S		; S   6   S  1

	
PR1:	SBIC EECR,EEWE
	RJMP PR1	;Ĩ  	
	LDI A,63	
	OUT EEAR,A	;  
	OUT EEDR,S	; 
	SBI EECR,EEWE	;    EEPROM
PR2:	SBIC EECR,EEWE
	RJMP PR2	;Ĩ   EEPROM  	

			
	RJMP DD  	; (  ,  )

PROG2:
	LDI S,0		; S   6  S=0
	RJMP PR1	;      

	
	













	
	
;******************************************************************
;     0.5  
;  8 .   0  127,5 .
;     delay  
;. delay=0     9 
;(1.125). CALL        .
;******************************************************************

PAUSE_MS:

   	cpi delay,0   ; 0      POINT
	brne POINT
	ret
POINT:	nop
	
	ldi x,12	; x    cikl

	ldi a,9
pool:	dec a
	brne pool
	
cikl:	ldi a,109
pool1:	dec a
	brne pool1
	dec x
	brne cikl	; 
	dec delay	; delay  1
	brne next	; 0      next
 	ret 
next:	nop
	ldi a,2
pool2:	dec a
	brne pool2	;   delay  = 0
	rjmp POINT
;*******************************************************************
; 
;*******************************************************************   









;*******************************************************************
;   EEPROM (  )
;*******************************************************************


EEPROM_RD:

 	OUT EEAR,SS	;   
	SBI EECR,EERE	; 
	IN A,EEDR	;      

	CPI A,2
	BRMI ERR	; <2    ERR ()
	LDI AA,8
	CP AA,A
	BRMI ERR	; >8    ERR ()
	
	RET		;

ERR:	LDI A,2		;       EEPROM

WR:

	SBIC EECR,EEWE
	RJMP WR 	;Ĩ  

	OUT EEAR,SS	;   
 	OUT EEDR,A	;   
	SBI EECR,EEWE	;  

WRR:	SBIC EECR,EEWE
	RJMP WRR 	;Ĩ   EEPROM  	
	
	RET		;
	

;*******************************************************************
; 		 
;*******************************************************************






MAX_S:
	TST MAX		;MAX ? ( 0 - )
	BREQ MAX_SA	;     MAX_SA ( )

	LDI MAX,0
	MOV A,MAX
	LDI SS,62	;      EEPROM
	RCALL WR	; MAX        EEPROM
	CBI PORTD,4	;  MAX
	RJMP OUT	;
MAX_SA:
	LDI MAX,3
	MOV A,MAX
	LDI SS,62	;      EEPROM
	RCALL WR	; MAX        EEPROM
	SBI PORTD,4	;  MAX
	RJMP OUT	;


COMP_S:
	;TST COMP	;COMP ? ( 0 - )
	;BREQ COMP_SA	;     COMP_SA ( )

	
	LDI COMP,0	;  
	;MOV A,COMP
	;LDI SS,61	;      EEPROM
	;RCALL WR	; COMP        EEPROM
	CBI PORTD,6	; COMP
	CLI 		; 
	;RJMP OUT1	;

OUT1:
	
	SBIS PIND,1
	RJMP OUT1	;    PROG
	LDI DELAY,250
	RCALL PAUSE_MS;   125 
	
	SBIS PIND,1
	RJMP OUT1	;      ,
			;   

	
	RET		

;COMP_SA:

	;
	;LDI COMP,1
	;MOV A,COMP
	;LDI SS,61	;      EEPROM
	;RCALL WR	; COMP        EEPROM
	;SBI PORTD,6	; COMP
	;SEI		; 
	;RJMP OUT1	;
	


OUT:
	
	SBIS PIND,0
	RJMP OUT	;    SPEED
	LDI DELAY,250
	RCALL PAUSE_MS;   125 
	
	SBIS PIND,0
	RJMP OUT	;      ,
			;   
	
	
	RET
		






OFF:	WDR		; 
	CBI PORTD,4
	CBI PORTD,5
	CBI PORTD,6
	CBI PORTB,3	;  




	CBI PORTB,2
	CBI PORTB,4	;  

	
	LDI DELAY,254
	RCALL PAUSE_MS	;   



END:	CBI PORTB,5	; 

	LDI DELAY,254
	RCALL PAUSE_MS	;	

	WDR		; 
	
	RJMP END	; 








;   21.05.2001.

;      SPEED,  
;     EEPROM 

;    PROG C   
; EEPROM.     -  
; .    
;  AUTO.

;      SPEED, , -
;, MAX.    MAX.  
;MAX    85  ,   
;  .      EEPROM.

;      PROG, ,
; .  .   
;     , 
;235 (  ) ,
;     .    -
;  EEPROM.

;     -      
; ( Q=2),   ( S=0),
;   .


;

;    .   -  
;  "" , " "  ""
; S.

;     .   
;      





    